/*
 *         
 * SmoothAlgorithms.mqh
 *   (): MetaTrader\\MQL5\Include
 */
//+------------------------------------------------------------------+
//|                                                   JFatlSpeed.mq5 |
//|                               Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "2010,   Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"

//----     
#property indicator_separate_window 
//----        
#property indicator_buffers 1
//----     
#property indicator_plots   1
//----     
#property indicator_type1   DRAW_LINE
//----        
#property indicator_color1  Blue
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----   
#property indicator_label1  "JFATL"
//+-----------------------------------+
//|         |
//+-----------------------------------+
enum Applied_price_ // 
  {
   PRICE_CLOSE_ = 1,     //PRICE_CLOSE
   PRICE_OPEN_,          //PRICE_OPEN
   PRICE_HIGH_,          //PRICE_HIGH
   PRICE_LOW_,           //PRICE_LOW
   PRICE_MEDIAN_,        //PRICE_MEDIAN
   PRICE_TYPICAL_,       //PRICE_TYPICAL
   PRICE_WEIGHTED_,      //PRICE_WEIGHTED
   PRICE_SIMPL_,         //PRICE_SIMPL_
   PRICE_QUARTER_,       //PRICE_QUARTER_
   PRICE_TRENDFOLLOW0_, //PRICE_TRENDFOLLOW0_
   PRICE_TRENDFOLLOW1_  //PRICE_TRENDFOLLOW1_
  };
input int Length_=8; //  JMA  Fatl                   
input int Phase_=100; //  JMA  Fatl,
                      //   -100 ... +100,
//    ;

input int MomPeriod=1;//  Momentum   

input int Smooth=2; //  JMA                    
input int SmPhase=100; //  JMA  ,
                       //   -100 ... +100,
//    ;

input Applied_price_ IPC=PRICE_CLOSE_;// 
/* ,      ( 1-CLOSE, 2-OPEN, 3-HIGH, 4-LOW, 
  5-MEDIAN, 6-TYPICAL, 7-WEIGHTED, 8-SIMPL, 9-QUARTER, 10-TRENDFOLLOW, 11-0.5 * TRENDFOLLOW.) */

input int FATLShift=0; //      
//+-----------------------------------+

//----          FATL
int FATLPeriod=39;

//----   ,    
//      
double ExtLineBuffer[];

int start,fstart,jfstart,mstart,FATLSize;
double dPriceShift;
//+------------------------------------------------------------------+
//   iPriceSeries()                                   |
//   CFATL, CJJMA  CMomentum                         |
//+------------------------------------------------------------------+ 
#include <SmoothAlgorithms.mqh>  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----    ExtLineBuffer   
   SetIndexBuffer(0,ExtLineBuffer,INDICATOR_DATA);
//----       FATLShift
   PlotIndexSetInteger(0,PLOT_SHIFT,FATLShift);
//----  
   fstart=FATLPeriod;
   jfstart=fstart+30;
   mstart=jfstart+MomPeriod;
   start=mstart+30;
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,start);
//----      
   string shortname;
   StringConcatenate(shortname,"JFATLSpeed(",Length_," ,",Phase_," ,",MomPeriod,")");
//----      DataWindow
   PlotIndexSetString(0,PLOT_LABEL,shortname);
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//----     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//----      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);
//----    CJJMA   JJMASeries_Cls.mqh
   CJJMA JMA;
//----       
   JMA.JJMALengthCheck("Length_", Length_);
   JMA.JJMAPhaseCheck("Phase_", Phase_);
   JMA.JJMALengthCheck("MomPeriod", MomPeriod);
   JMA.JJMALengthCheck("Smooth", Smooth);
   JMA.JJMAPhaseCheck("SmPhase", SmPhase);
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(rates_total<start)
      return(0);

//----    
   int first,bar;
   double price,jfatl,fatl,jmom,jfspeed;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=0; //      
     }
   else first=prev_calculated-1; //      

//----    CFATL, CJJMA  CMomentum   JJMASeries_Cls.mqh
   static CJJMA JMA1,JMA2;
   static CFATL FATL;
   static CMomentum MOM;

//----    
   for(bar=first; bar<rates_total; bar++)
     {
      //----    price
      price=PriceSeries(IPC,bar,open,low,high,close);

      //----    price  FATLSeries()   fatl
      fatl=FATL.FATLSeries(0,prev_calculated,rates_total,price,bar,false);

      //----  fatl  JJMASeries()   jfatl
      jfatl=JMA1.JJMASeries(fstart,prev_calculated,rates_total,0,Phase_,Length_,fatl,bar,false);

      //----  jfatl  MomentumSeries()   jmom
      jmom=MOM.MomentumSeries(jfstart,prev_calculated,rates_total,MomPeriod,jfatl,bar,false);

      //----  jmom  JJMASeries()   jfspeed
      jfspeed=JMA2.JJMASeries(mstart,prev_calculated,rates_total,0,SmPhase,Smooth,jmom,bar,false);

      //----      
      jfspeed/=_Point;

      //----  jfspeed   
      ExtLineBuffer[bar]=jfspeed;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
